﻿using System;
using System.Windows.Forms;

namespace ncvcommentmado
{
    public partial class CommentForm : Form
    {
        public delegate bool PostCommandEventHandler(bool isOwner, bool isAnonymous, string comment);
        public event PostCommandEventHandler PostCommand;


        #region メソッド

        public CommentForm()
        {
            InitializeComponent();
        }

        #endregion


        #region プロパティ

        /// <summary>
        /// 送信ボタンの有効化・無効化
        /// </summary>
        public bool PostButtonEnabled
        {
            get { return postButton.Enabled; }
            set { postButton.Enabled = value; }
        }

        #endregion


        #region イベントハンドラ（的なもの）

        /// <summary>
        /// コマンドキーボードショートカット対応
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            Keys code = keyData & Keys.KeyCode;
            Keys mod = keyData & Keys.Modifiers;

            if (mod == Keys.Control)
            {
                switch (code)
                {
                    case Keys.Enter:
                        Post();
                        return true;
                    case Keys.A:
                        commentTextBox.SelectAll();
                        return true;
                }
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        void postButton_Click(object sender, EventArgs e)
        {
            Post();
        }

        #endregion


        #region サブルーチン

        /// <summary>
        /// コメント送信
        /// </summary>
        void Post()
        {
            if (postButton.Enabled)
            {
                if (PostCommand(isOwnerCheckBox.Checked, isAnonymousCheckBox.Checked, commentTextBox.Text)) {// 成功
                    commentTextBox.Text = "";
                }
            }
        }

        #endregion
    }
}
